
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 101
#define YY_END_OF_BUFFER 102
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[505] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  102,  100,   99,   99,  100,  100,
      100,   42,   72,  100,  100,  100,  100,   77,  100,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   43,   44,   71,   99,   72,  100,  100,  100,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   92,   91,   91,   92,   92,   78,   80,   92,
       83,   79,   81,   82,   89,   89,   89,   55,   55,   54,
       53,   52,   40,   39,   39,   40,   38,   36,   36,   38,
       38,   38,   11,   13,   38,   17,   18,    9,   12,    8,

       14,   10,   32,   32,    3,   24,    7,   25,   37,   37,
       37,   37,   37,   37,   37,   15,   16,    0,    0,   98,
        0,    0,   76,   76,   76,   74,   85,   77,    0,   77,
       77,   77,   77,   77,    1,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,    0,    0,    0,
        0,    0,    0,    0,    0,   76,    0,    0,    0,   77,
       77,   77,   77,   77,   77,   77,   77,    1,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
        0,   84,    0,    0,   90,   86,   79,   89,   89,   88,
       56,   52,   41,   22,    0,   35,    0,    0,   33,    0,

       34,    0,   87,   30,    0,   32,   20,   23,   19,   21,
       37,   37,   37,   37,    4,   37,   37,    0,   94,    0,
       93,    0,    0,   96,    0,   76,   76,   73,   73,   74,
       75,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   48,   77,   77,   77,   77,   70,
        0,   97,   76,    0,    0,   70,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   48,
       77,   77,   77,   77,    0,    0,    0,   33,    0,    0,
       31,    5,   37,    6,   37,   37,    0,   95,   76,   73,
       73,   75,   77,   47,   77,   77,   46,   77,   77,   77,

       77,   77,   77,   77,   77,   77,   45,   77,   77,   77,
        0,    0,    0,   77,   47,   77,   77,   46,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   45,   77,   77,
       77,    0,    0,    0,    0,    0,   37,   37,    2,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   49,    0,    0,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   49,
        0,   37,   37,   77,   77,   77,   77,    0,   65,   77,
       77,   77,   77,   77,   77,   77,   77,   77,    0,    0,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,

       77,   77,   37,   37,    0,   68,   77,   77,    0,   60,
       77,   77,    0,   66,    0,   59,   77,   77,   77,   77,
       77,    0,   69,    0,   77,   77,   77,   77,   77,   77,
       77,   37,   37,   77,   50,   77,   77,   77,   77,    0,
       62,   77,   77,   69,   77,   50,   77,   77,   77,   77,
       26,   37,    0,   64,   77,   77,   77,    0,   63,    0,
       61,    0,   58,   77,   37,   37,   77,   77,   77,   77,
       27,   28,   77,    0,   57,   77,   77,   37,   77,   77,
       77,   29,    0,   67,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,

       77,   77,   51,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
       46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
       56,   57,   58,   29,   59,    1,   60,   61,   62,   63,

       64,   65,   66,   67,   68,   39,   69,   70,   71,   72,
       73,   74,   75,   76,   77,   78,   79,   51,   80,   81,
       82,   83,   84,   29,   85,   86,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[87] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,   13,   14,
       14,   15,   16,   17,    1,   18,    1,   19,    1,   20,
       21,   22,   22,   22,   20,   23,   23,   23,   23,   23,
       23,   23,   24,   23,   23,   23,   24,   23,   24,   23,
       25,   23,   26,   23,   23,    1,    6,    1,   27,   20,
       21,   22,   22,   22,   20,   23,   23,   23,   23,   23,
       23,   24,   23,   23,   23,   24,   23,   24,   23,   23,
       26,   23,   23,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[580] =
    {   0,
        0,   86,  172,    0,  256,  257,  259,  262,  254,  259,
      281,    0,  367,    0, 1241, 3528, 3528, 3528,    0, 1185,
        0, 3528, 3528, 1171,  254,    0, 1161,    0,    0,  422,
      425,  416,  417,  424,  417,  432,  433,  415,  439,  436,
      423, 3528, 3528,    0,  495,  461, 1154,  518,  494,  534,
      547,  593,  556,  589,  604,  568,  594,  613,  601,  638,
      641,  640, 3528, 3528, 3528,  450, 1057, 3528, 3528, 1044,
     3528,    0, 3528, 3528, 1044, 1041,  965,    0, 3528, 3528,
     3528,  518, 3528, 3528, 3528,    0, 3528, 3528, 3528,  952,
      500,  565, 3528, 3528,  464, 3528, 3528, 3528, 3528, 3528,

     3528,  960,  539,  558, 3528,  251,  945,  934,  429,    0,
      509,  528,  542,  572,  441, 3528, 3528,  688,  936, 3528,
      716,  692,    0,  801,  457,    0, 3528,    0,  902,  578,
      595,  635,  633,  762,    0,  762,  765,  445,  562,  763,
      777,  772,  765,  771,  774,  775,  770,  847,  804,    0,
      910,  810,    0,  836,  830,  870,  883,  583,  884,  898,
      845,  916,  927,  909,  874,  844,  915,  770,  916,  918,
      791,  920,  919,  936,  932,  809,  928,  940,  950,  955,
      575, 3528,  515,  865, 3528, 3528,    0,  809,  712, 3528,
        0,  888,    0, 3528,  636, 3528,  987,    0,    0,  583,

     3528,  992, 3528,  683,    0,  995, 3528, 3528, 3528, 3528,
        0,  572,  847,  970,    0,  628,  789, 1020, 3528,  660,
     3528, 1073, 1023, 1032,  652, 1039,  641,    0,    0,    0,
        0,  799,  979,  989,  995, 1000, 1110, 1121, 1119, 1113,
     1116, 1120, 1121, 1133,    0, 1124, 1125, 1137, 1138,    0,
     1048, 3528, 1051,  898, 1052, 1191, 1162, 1211, 1166, 1140,
     1181, 1170, 1178, 1196, 1204, 1205, 1193, 1214, 1223, 1146,
     1215, 1220, 1228, 1237, 1252, 1042,    0,    0, 1044,    0,
     3528,    0, 1227,    0, 1230, 1236,  619, 3528,  582,    0,
        0,    0, 1242,    0, 1242, 1135,    0, 1250, 1246, 1246,

      482, 1256, 1265, 1255, 1266, 1255,    0, 1263,  772, 1262,
     1065, 1067, 1312, 1277, 1271, 1273, 1296, 1272, 1297, 1295,
     1298, 1304, 1282, 1312, 1308, 1328, 1313, 1315, 1317, 1331,
     1330, 1374, 1203,    0, 1339,    0, 1345, 1321,    0, 1338,
     1358, 1348, 1352, 1400, 1351, 1351, 1355, 1359, 1363, 1362,
     1377, 1383, 1371,    0, 1412,  584, 1380, 1399, 1391, 1376,
     1445, 1392, 1417, 1398, 1383, 1413, 1430, 1435, 1426, 1414,
      640, 1404, 1425, 1476, 1432, 1427, 1489, 1505, 3528,  432,
     1432, 1510, 1516, 1465, 1454, 1461, 1467, 1478,  702,  854,
     1521, 1488, 1485, 1534, 1489, 1539, 1564, 1508, 1503, 1512,

     1516, 1513, 1491,  883, 1585, 3528, 1520, 1513, 1598, 3528,
     1525, 1550, 1604, 3528, 1609, 3528, 1557, 1517, 1615, 1559,
     1561, 1573, 3528, 1590, 1579, 1590, 1591, 1588, 1633, 1599,
     1607, 1567, 1600, 1663,    0, 1613, 1600, 1608, 1678, 1681,
     3528, 1684, 1695, 1645, 1702, 1621, 1651, 1706, 1713, 1720,
      409, 1623, 1724, 3528, 1633, 1666, 1670, 1746, 3528, 1753,
     3528, 1765, 3528, 1671, 1691, 1696, 1672, 1776, 1700, 1711,
        0,  405, 1710, 1782, 3528, 1690, 1696, 1724, 1793, 1732,
     1760,    0, 1800, 3528, 1710, 1746, 1757, 1765, 1750, 1766,
     1758, 1769, 1769, 1772, 1784, 1786, 1786, 1790, 1776, 1785,

      257, 1821, 3528, 3528, 1891, 1918, 1945, 1972, 1999, 2007,
     2033, 2060, 2079, 2093, 2118, 2137, 2156, 2182, 2203, 2222,
     2249, 2276, 2292, 2319, 2346, 2362, 2389, 2412, 2438, 2452,
     2479, 2506, 2533, 2560, 2579, 2593, 2618, 2637, 2653, 2673,
     2695, 2721, 2745, 2767, 2787, 2814, 2836, 2861, 2877, 2904,
     2931, 2947, 2974, 2996, 3003, 3025, 3052, 3074, 1837, 3087,
     3114, 3141, 3168, 3195, 3222, 3249, 3276, 3303, 3322, 3345,
     3368, 3390, 3410, 3437, 3451, 3460, 3469, 3478, 3500
    } ;

static yyconst flex_int16_t yy_def[580] =
    {   0,
      504,  504,  504,    3,  505,  505,  506,  506,  507,  507,
      504,   11,  504,   13,  504,  504,  504,  504,  508,  509,
      510,  504,  504,  504,  511,  511,  512,  513,  514,  513,
      513,  513,  513,  513,  513,  513,  513,  513,  513,  513,
      513,  504,  504,  511,  515,  516,  517,  518,  519,  520,
      520,  520,   52,   52,   52,   52,   52,   52,   52,   52,
       52,   52,  504,  504,  504,  521,  522,  504,  504,  504,
      504,  523,  504,  504,  524,  524,  504,  525,  504,  504,
      504,  504,  504,  504,  504,  526,  504,  504,  504,  504,
      527,  528,  504,  504,  529,  504,  504,  504,  504,  504,

      504,  504,  504,  504,  504,  504,  504,  504,  530,  530,
      530,  530,  530,  530,  530,  504,  504,  531,  532,  504,
      504,  504,  511,  511,  533,  534,  504,  535,  536,  535,
      535,  535,  535,  535,  535,  535,  535,  535,  535,  535,
      535,  535,  535,  535,  535,  535,  535,  537,  538,  539,
      540,  538,  541,  504,  539,  542,  540,  540,  543,  544,
      535,  545,  545,  163,  163,  163,  163,  163,  163,  163,
      163,  163,  163,  163,  163,  163,  163,  163,  163,  163,
      546,  504,  547,  548,  504,  504,  549,  550,  550,  504,
      551,  504,  552,  504,  553,  504,  554,  555,  556,  557,

      504,  558,  504,  504,  559,  504,  504,  504,  504,  504,
      560,  560,  560,  560,  560,  560,  560,  504,  504,  561,
      504,  504,  504,  504,  562,  563,  564,  565,  566,  567,
      568,  569,  569,  569,  569,  569,  569,  569,  569,  569,
      569,  569,  569,  569,  569,  569,  569,  569,  569,  570,
      504,  504,  563,  504,  571,  572,  573,  573,  258,  258,
      258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
      258,  258,  258,  258,  574,  504,  575,  556,  504,  576,
      504,  560,  560,  560,  560,  560,  562,  504,  564,  565,
      566,  568,  569,  569,  569,  569,  569,  569,  569,  569,

      569,  569,  569,  569,  569,  569,  569,  569,  569,  569,
      571,  571,  571,  258,  258,  258,  258,  258,  258,  258,
      258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
      258,  574,  504,  577,  504,  578,  560,  560,  560,  569,
      569,  569,  569,  569,  569,  569,  569,  569,  569,  569,
      569,  569,  569,  569,  504,  504,  258,  258,  258,  258,
      258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
      574,  560,  560,  569,  569,  569,  569,  504,  504,  569,
      569,  569,  569,  569,  569,  569,  569,  569,  504,  579,
      258,  258,  258,  258,  258,  258,  258,  258,  258,  258,

      258,  258,  560,  560,  504,  504,  569,  569,  504,  504,
      569,  569,  504,  504,  504,  504,  569,  569,  569,  569,
      569,  579,  504,  579,  258,  258,  258,  258,  258,  258,
      258,  560,  560,  569,  569,  569,  569,  569,  569,  504,
      504,  569,  569,  579,  258,  258,  258,  258,  258,  258,
      560,  560,  504,  504,  569,  569,  569,  504,  504,  504,
      504,  504,  504,  258,  560,  560,  569,  569,  569,  258,
      560,  560,  569,  504,  504,  569,  258,  560,  569,  569,
      258,  560,  504,  504,  569,  258,  569,  258,  569,  258,
      569,  258,  569,  258,  569,  258,  569,  258,  569,  258,

      569,  258,  504,    0,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504
    } ;

static yyconst flex_int16_t yy_nxt[3615] =
    {   0,
       16,   17,   18,   17,   19,   16,   20,   21,   16,   22,
       16,   16,   16,   23,   24,   16,   25,   26,   27,   28,
       28,   28,   29,   16,   16,   16,   26,   26,   26,   30,
       28,   31,   28,   32,   28,   33,   28,   34,   28,   28,
       35,   36,   28,   28,   37,   28,   38,   39,   40,   41,
       28,   28,   28,   28,   28,   16,   16,   16,   28,   30,
       28,   31,   28,   32,   28,   33,   28,   34,   28,   35,
       36,   28,   28,   37,   28,   38,   39,   40,   41,   28,
       28,   28,   28,   42,   43,   44,   16,   45,   18,   45,
       19,   16,   20,   21,   16,   22,   16,   16,   16,   46,

       47,   16,   48,   26,   27,   28,   28,   28,   49,   16,
       16,   16,   26,   26,   26,   50,   51,   52,   51,   53,
       51,   54,   51,   55,   51,   51,   56,   57,   51,   51,
       58,   51,   59,   60,   61,   62,   51,   51,   51,   51,
       51,   16,   16,   16,   28,   50,   51,   52,   51,   53,
       51,   54,   51,   55,   51,   56,   57,   51,   51,   58,
       51,   59,   60,   61,   62,   51,   51,   51,   51,   42,
       43,   44,   63,   64,   65,   64,   63,   66,   67,   63,
       63,   63,   63,   63,   68,   63,   63,   69,   63,   63,
       70,   63,   63,   63,   63,   63,   63,   71,   63,   63,

       63,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   73,   63,   74,
       63,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   63,   63,   63,   76,   76,
       79,   79,   79,   79,   79,   79,   81,  124,  503,   77,
       77,   81,  125,   82,   82,   82,  207,  208,   82,   82,
       82,   83,   84,   85,   84,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,

       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   83,   83,   83,   83,
       86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   86,   86,   86,   86,   86,   86,
       86,   86,   86,   86,   83,   83,   83,   87,   88,   89,
       88,   90,   91,   87,   92,   93,   94,   95,   96,   97,
       98,   99,  100,  101,   87,  102,  103,  104,  104,   87,
      105,  106,  107,  108,   87,   87,  109,  110,  111,  110,

      110,  110,  110,  110,  110,  110,  110,  110,  110,  112,
      113,  110,  110,  110,  114,  115,  110,  110,  110,  110,
      110,  110,  116,   87,  117,   87,  109,  110,  111,  110,
      110,  110,  110,  110,  110,  110,  110,  110,  112,  113,
      110,  110,  110,  114,  115,  110,  110,  110,  110,  110,
       87,   87,   87,  130,  131,  182,  133,  134,  135,  229,
      137,  138,  140,  478,  142,  147,  136,  465,  132,  145,
      123,  212,  143,  146,  201,  139,  153,  217,  153,  141,
      154,  154,  239,  130,  131,  133,  134,  144,  135,  137,
      411,  138,  140,  142,  147,  136,  148,  132,  148,  145,

      212,  157,  143,  146,  139,  196,  183,  217,  141,  150,
      158,  150,  239,  129,  129,  129,  144,  151,  123,  123,
      202,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  124,  123,  123,  275,  275,  125,  192,  192,  192,
      346,  123,  123,  123,  123,  123,  123,  152,  128,  160,
      128,  153,  213,  161,  161,  128,  197,  128,  204,  204,
      152,  128,  160,  128,  153,  163,  161,  161,  128,  198,
      128,  214,  198,  123,  123,  123,  123,  206,  206,  206,
      182,  213,  198,  198,  288,  162,  254,  389,  215,  390,
      504,  205,  128,  201,  240,  163,  166,  162,  255,  162,

      214,  123,  123,  123,  282,  128,  152,  128,  160,  128,
      153,  170,  161,  161,  128,  162,  128,  215,  162,  205,
      216,  288,  164,  171,  240,  166,  232,  162,  162,  167,
      162,  183,  162,  162,  282,  233,  165,  172,  168,  202,
      170,  196,  173,  288,  162,  182,  169,  162,  162,  216,
      175,  128,  164,  171,  288,  232,  162,  285,  167,  174,
      162,  162,  221,  162,  233,  165,  172,  162,  168,  162,
      162,  176,  173,  162,  178,  169,  162,  234,  179,  175,
      235,  162,  180,  162,  162,  162,  177,  285,  174,  218,
      219,  218,  197,  223,  224,  223,  183,  162,  225,  162,

      162,  176,  204,  204,  178,  389,  234,  390,  179,  235,
      162,  180,  162,  162,  189,  177,  220,  220,  221,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  220,  220,  220,  220,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  220,

      220,  220,  226,  224,  226,  236,  237,  227,  238,  241,
      242,  189,  244,  245,  246,  247,  248,  249,  162,  153,
      243,  153,  286,  154,  154,  153,  353,  153,  264,  154,
      154,  251,  252,  251,  236,  237,  293,  238,  241,  162,
      242,  244,  245,  246,  247,  248,  249,  162,  148,  243,
      148,  153,  286,  153,  353,  154,  154,  270,  264,  423,
      160,  150,  153,  150,  161,  161,  293,  185,  162,  151,
      123,  253,  252,  253,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  270,  254,  123,  283,
      504,  260,  162,  123,  123,  123,  123,  123,  123,  255,

      158,  254,  250,  129,  129,  129,  231,  192,  192,  192,
      424,  250,  128,  255,  128,  250,  259,  157,  283,  128,
      260,  162,  162,  250,  231,  123,  123,  123,  123,  152,
      128,  160,  128,  153,  433,  161,  161,  128,  120,  128,
      152,  128,  160,  128,  153,  259,  161,  161,  128,  258,
      128,  162,  265,  123,  123,  123,  128,  162,  261,  210,
      262,  263,  433,  162,  162,  266,  162,  162,  162,  267,
      209,  271,  269,  203,  128,  257,  162,  194,  258,  268,
      162,  272,  265,  190,  162,  128,  162,  261,  162,  262,
      263,  273,  162,  162,  266,  162,  162,  162,  162,  267,

      271,  269,  274,  162,  257,  162,  276,  276,  268,  162,
      272,  279,  279,  162,  206,  206,  206,  162,  284,  294,
      273,  218,  219,  218,  223,  224,  223,  162,  297,  225,
      298,  274,  162,  223,  224,  223,  295,  296,  225,  277,
      226,  224,  226,  189,  280,  227,  189,  284,  294,  251,
      252,  251,  253,  252,  253,  311,  312,  186,  297,  185,
      298,  333,  333,  335,  335,  295,  296,  277,  311,  312,
      504,  504,  280,  220,  220,  221,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,

      220,  220,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  220,  220,
      220,  220,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  220,  220,  220,  299,
      300,  301,  302,  303,  304,  305,  306,  122,  307,  308,
      309,  310,  342,  318,  127,  152,  128,  160,  128,  153,
      162,  161,  161,  128,  122,  128,  162,  120,  299,  300,
      301,  302,  303,  304,  305,  250,  306,  307,  308,  314,

      309,  310,  342,  318,  250,  128,  162,  128,  250,  162,
      162,  319,  128,  316,  317,  162,  250,  321,  162,  320,
      128,  162,  195,  195,  152,  128,  160,  128,  153,  314,
      161,  161,  128,  162,  128,  162,  162,  325,  322,  162,
      504,  319,  316,  317,  162,  162,  321,  162,  320,  128,
      162,  315,  324,  323,  162,  162,  327,  182,  326,  328,
      162,  330,  162,  162,  329,  162,  325,  322,  162,  128,
      331,  332,  332,  162,  162,  337,  338,  162,  339,  343,
      315,  324,  323,  162,  162,  340,  327,  326,  328,  162,
      341,  330,  162,  329,  344,  345,  347,  162,  348,  350,

      331,  349,  351,  352,  337,  338,  162,  339,  183,  343,
      354,  162,  162,  162,  340,  355,  504,  162,  504,  341,
      357,  358,  363,  344,  345,  347,  360,  356,  348,  350,
      349,  351,  352,  359,  504,  162,  162,  162,  162,  354,
      162,  162,  162,  361,  162,  364,  162,  362,  162,  357,
      358,  363,  162,  162,  365,  162,  360,  368,  200,  200,
      367,  366,  346,  359,  162,  162,  162,  162,  162,  373,
      162,  162,  361,  162,  372,  364,  362,  162,  370,  182,
      374,  162,  162,  365,  162,  369,  368,  375,  382,  367,
      376,  366,  377,  371,  371,  380,  381,  162,  373,  162,

      162,  378,  378,  378,  372,  383,  384,  370,  385,  374,
      386,  379,  387,  369,  388,  355,  394,  375,  382,  376,
      162,  377,  391,  162,  380,  381,  398,  356,  392,  504,
      183,  162,  162,  393,  383,  384,  395,  385,  162,  162,
      386,  403,  387,  388,  397,  394,  378,  378,  378,  162,
      396,  391,  162,  162,  162,  398,  379,  162,  392,  399,
      162,  162,  393,  400,  401,  395,  162,  162,  162,  402,
      162,  403,  404,  397,  407,  162,  408,  405,  405,  405,
      396,  412,  162,  162,  504,  162,  162,  406,  399,  504,
      409,  409,  409,  400,  401,  162,  417,  504,  402,  162,

      410,  404,  418,  407,  162,  408,  378,  378,  378,  419,
      412,  413,  413,  413,  162,  420,  379,  415,  415,  415,
      421,  414,  405,  405,  405,  162,  417,  416,  162,  162,
      425,  418,  406,  432,  426,  409,  409,  409,  419,  427,
      413,  413,  413,  162,  420,  410,  435,  411,  162,  421,
      414,  428,  162,  162,  162,  431,  162,  162,  162,  425,
      429,  162,  432,  426,  430,  415,  415,  415,  434,  427,
      439,  504,  162,  436,  162,  416,  435,  162,  423,  162,
      428,  162,  162,  437,  431,  162,  405,  405,  405,  429,
      162,  438,  442,  430,  443,  444,  406,  434,  439,  409,

      409,  409,  436,  162,  162,  413,  413,  413,  162,  410,
      415,  415,  415,  437,  451,  414,  440,  440,  440,  162,
      416,  438,  442,  446,  443,  447,  441,  445,  162,  424,
      162,  162,  449,  162,  440,  440,  440,  452,  504,  162,
      450,  448,  455,  451,  441,  457,  424,  162,  162,  456,
      423,  504,  504,  446,  504,  447,  445,  162,  504,  162,
      162,  162,  449,  467,  453,  453,  453,  452,  162,  448,
      450,  466,  455,  162,  454,  457,  162,  504,  456,  458,
      458,  458,  440,  440,  440,  460,  460,  460,  464,  459,
      162,  162,  441,  467,  504,  461,  462,  462,  462,  468,

      466,  424,  162,  453,  453,  453,  463,  458,  458,  458,
      469,  470,  473,  454,  460,  460,  460,  459,  464,  504,
      162,  462,  462,  462,  461,  453,  453,  453,  471,  468,
      480,  463,  472,  476,  504,  454,  481,  504,  504,  469,
      470,  473,  162,  479,  477,  504,  162,  458,  458,  458,
      504,  162,  487,  162,  460,  460,  460,  459,  471,  480,
      162,  482,  472,  476,  461,  481,  462,  462,  462,  485,
      504,  162,  504,  479,  477,  162,  463,  474,  474,  474,
      162,  487,  162,  474,  474,  474,  162,  475,  488,  162,
      489,  482,  491,  475,  483,  483,  483,  486,  490,  485,

      162,  483,  483,  483,  484,  162,  162,  493,  492,  162,
      495,  484,  162,  496,  497,  162,  498,  488,  494,  499,
      489,  491,  501,  500,  504,  162,  162,  486,  490,  162,
      162,  502,  503,  504,  162,  162,  493,  492,  162,  495,
      504,  162,  496,  504,  497,  504,  498,  494,  504,  499,
      281,  501,  504,  500,  162,  162,  281,  281,  281,  162,
      502,  162,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      162,   75,   75,   75,   75,   75,   75,   75,   75,   75,

       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,  118,  504,  504,  504,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  119,

      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  121,  121,  121,  121,
      121,  121,  121,  123,  123,  504,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  126,  126,  126,
      126,  126,  126,  126,  126,  126,  126,  128,  128,  128,
      504,  504,  128,  128,  504,  128,  504,  504,  128,  128,

      128,  128,  128,  128,  128,  128,  129,  129,  504,  504,
      504,  504,  129,  129,  129,  129,  129,  129,  129,  149,
      504,  149,  504,  504,  504,  149,  149,  504,  149,  504,
      504,  504,  504,  149,  504,  504,  504,  149,  149,  149,
      149,  149,  149,  149,  152,  504,  152,  504,  152,  504,
      152,  504,  504,  504,  504,  504,  152,  152,  152,  152,
      152,  152,  152,  155,  504,  504,  155,  155,  504,  155,
      155,  155,  504,  504,  504,  155,  155,  155,  155,  155,
      155,  155,  156,  156,  504,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,

      156,  156,  156,  156,  156,  156,  156,  156,  156,  159,
      504,  504,  504,  159,  504,  504,  159,  159,  504,  504,
      504,  504,  159,  159,  159,  159,  159,  159,  159,  162,
      162,  162,  162,  162,  504,  162,  162,  504,  162,  504,
      504,  162,  162,  162,  162,  162,  162,  162,  162,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,

      184,  184,  184,  187,  504,  187,  187,  504,  504,  504,
      504,  187,  187,  187,  187,  187,  187,  187,  187,  188,
      188,  188,  188,  188,  188,  188,  504,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  191,  504,  504,  504,
      191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
      191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
      191,  191,  191,  193,  504,  193,  193,  504,  504,  504,
      504,  193,  193,  193,  193,  193,  193,  193,  193,  195,
      195,  195,  195,  195,  195,  504,  195,  195,  195,  195,

      195,  195,  195,  195,  195,  195,  195,  195,  195,  195,
      195,  195,  195,  195,  195,  195,  199,  504,  199,  504,
      504,  504,  504,  199,  199,  504,  504,  504,  504,  504,
      504,  199,  199,  199,  199,  199,  199,  199,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  211,  211,  504,  504,  504,
      504,  211,  211,  211,  211,  211,  211,  211,  211,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,

      118,  118,  118,  118,  118,  118,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  119,  119,  119,  119,  119,  119,  119,
      119,  119,  119,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      230,  230,  504,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  128,  128,  128,
      504,  504,  128,  128,  504,  128,  504,  504,  128,  128,

      128,  128,  128,  128,  128,  128,  129,  129,  129,  504,
      504,  504,  129,  129,  129,  129,  129,  129,  129,  149,
      504,  149,  504,  504,  504,  149,  149,  504,  149,  504,
      504,  504,  504,  149,  504,  504,  504,  149,  149,  149,
      149,  149,  149,  149,  152,  504,  152,  504,  152,  504,
      152,  504,  504,  504,  504,  504,  152,  152,  152,  152,
      152,  152,  152,  155,  155,  504,  155,  155,  155,  504,
      504,  504,  155,  155,  155,  155,  155,  155,  155,  158,
      504,  504,  504,  158,  504,  504,  504,  504,  504,  504,
      504,  504,  158,  158,  158,  158,  158,  158,  158,  250,

      504,  504,  250,  504,  250,  504,  250,  504,  250,  504,
      504,  250,  250,  504,  250,  250,  250,  250,  250,  250,
      250,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  159,  504,
      504,  504,  504,  504,  159,  159,  504,  504,  159,  159,
      159,  504,  504,  504,  159,  159,  159,  159,  159,  159,
      159,  256,  504,  504,  256,  256,  256,  256,  256,  504,
      256,  256,  504,  256,  256,  504,  256,  256,  256,  256,
      256,  256,  256,  256,  162,  162,  162,  162,  162,  504,

      162,  162,  504,  162,  504,  504,  162,  162,  162,  162,
      162,  162,  162,  162,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  504,  504,  504,  504,  504,  504,  504,  181,
      504,  504,  504,  504,  181,  181,  181,  504,  504,  181,
      181,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  187,  504,
      187,  187,  504,  504,  504,  504,  187,  187,  187,  187,

      187,  187,  187,  187,  188,  188,  188,  188,  188,  188,
      188,  504,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  191,  504,  504,  504,  191,  191,  191,  191,  191,
      191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
      191,  191,  191,  191,  191,  191,  191,  191,  193,  504,
      193,  193,  504,  504,  504,  504,  193,  193,  193,  193,
      193,  193,  193,  193,  195,  195,  195,  195,  195,  195,
      504,  195,  195,  195,  195,  195,  195,  195,  195,  195,
      195,  195,  195,  195,  195,  195,  195,  195,  195,  195,

      195,  195,  195,  504,  504,  504,  504,  504,  504,  195,
      504,  504,  504,  504,  504,  504,  195,  504,  504,  195,
      504,  195,  199,  199,  199,  199,  199,  199,  199,  278,
      504,  504,  504,  504,  504,  278,  278,  504,  278,  278,
      504,  504,  504,  504,  278,  278,  278,  278,  278,  278,
      278,  278,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  504,  504,  504,  504,  504,  504,  200,  504,  504,
      504,  504,  504,  504,  200,  504,  504,  200,  504,  200,

      211,  211,  504,  504,  504,  504,  211,  211,  211,  211,
      211,  211,  211,  211,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  287,  287,
      287,  287,  287,  287,  287,  287,  287,  287,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  289,  289,  289,  289,  289,

      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  289,  289,  289,  289,  289,  289,  289,  289,
      289,  289,  290,  290,  504,  290,  290,  290,  290,  290,
      290,  290,  290,  290,  290,  290,  290,  290,  290,  290,
      290,  290,  290,  290,  290,  290,  290,  290,  290,  291,
      291,  504,  291,  291,  291,  291,  291,  291,  291,  291,
      291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
      291,  291,  291,  291,  291,  291,  230,  230,  504,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
      230,  230,  230,  230,  230,  230,  230,  230,  230,  230,

      230,  230,  230,  292,  292,  504,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      292,  292,  292,  292,  292,  292,  292,  292,  292,  292,
      128,  128,  128,  504,  504,  128,  128,  504,  128,  504,
      504,  128,  128,  128,  128,  128,  128,  128,  128,  250,
      504,  504,  250,  504,  250,  504,  250,  504,  250,  504,
      504,  250,  250,  504,  250,  250,  250,  250,  250,  250,
      250,  313,  313,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  313,  313,  313,
      313,  313,  313,  313,  256,  504,  504,  256,  256,  256,

      256,  256,  504,  256,  256,  504,  256,  256,  504,  256,
      256,  256,  256,  256,  256,  256,  256,  162,  162,  162,
      162,  162,  504,  162,  162,  504,  162,  504,  504,  162,
      162,  162,  162,  162,  162,  162,  162,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  181,  181,  181,  181,  181,  181,
      181,  181,  181,  181,  334,  334,  504,  504,  504,  504,
      334,  334,  334,  336,  336,  504,  504,  504,  504,  336,
      336,  336,  195,  195,  504,  504,  504,  504,  195,  195,
      195,  200,  200,  504,  504,  504,  504,  200,  200,  200,

      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,   15,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,

      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504
    } ;

static yyconst flex_int16_t yy_chk[3615] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    5,    6,
        7,    7,    7,    8,    8,    8,    9,   25,  501,    5,
        6,   10,   25,    9,    9,    9,  106,  106,   10,   10,
       10,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   30,   31,   66,   32,   33,   34,  125,
       35,   36,   37,  472,   38,   41,   34,  451,   31,   40,
      125,  109,   39,   40,   95,   36,   46,  115,   46,   37,
       46,   46,  138,   30,   31,   32,   33,   39,   34,   35,
      380,   36,   37,   38,   41,   34,   45,   31,   45,   40,

      109,   49,   39,   40,   36,   91,   66,  115,   37,   45,
       49,   45,  138,   49,   49,   49,   39,   45,   48,   48,
       95,   48,   48,   48,   48,   48,   48,   48,   48,   48,
       48,   48,   48,   48,  183,  183,   48,   82,   82,   82,
      301,   48,   48,   48,   48,   48,   48,   50,   50,   50,
       50,   50,  111,   50,   50,   50,   91,   50,  103,  103,
       51,   51,   51,   51,   51,   50,   51,   51,   51,   92,
       51,  112,   92,   48,   48,   48,   48,  104,  104,  104,
      181,  111,   92,   92,  289,   53,  158,  356,  113,  356,
      158,  103,   50,  200,  139,   50,   53,   56,  158,   53,

      112,   48,   48,   48,  212,   51,   52,   52,   52,   52,
       52,   56,   52,   52,   52,   53,   52,  113,   54,  103,
      114,  287,   52,   57,  139,   53,  130,   56,   53,   54,
       59,  181,   54,   55,  212,  131,   52,   57,   55,  200,
       56,  195,   58,  227,   59,  371,   55,   55,   54,  114,
       59,   52,   52,   57,  225,  130,   58,  216,   54,   58,
       59,   54,  220,   55,  131,   52,   57,   60,   55,   62,
       61,   60,   58,   59,   61,   55,   55,  132,   61,   59,
      133,   60,   62,   62,   61,   58,   60,  216,   58,  118,
      118,  118,  195,  122,  122,  122,  371,   60,  122,   62,

       61,   60,  204,  204,   61,  389,  132,  389,   61,  133,
       60,   62,   62,   61,  189,   60,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
      121,  121,  121,  121,  121,  121,  121,  121,  121,  121,

      121,  121,  124,  124,  124,  134,  136,  124,  137,  140,
      141,  188,  142,  143,  144,  145,  146,  147,  168,  149,
      141,  149,  217,  149,  149,  152,  309,  152,  171,  152,
      152,  155,  155,  155,  134,  136,  232,  137,  140,  171,
      141,  142,  143,  144,  145,  146,  147,  168,  148,  141,
      148,  154,  217,  154,  309,  154,  154,  176,  171,  390,
      161,  148,  161,  148,  161,  161,  232,  184,  171,  148,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  176,  159,  156,  213,
      157,  166,  166,  156,  156,  156,  156,  156,  156,  159,

      159,  254,  160,  159,  159,  159,  159,  192,  192,  192,
      390,  160,  160,  254,  160,  160,  165,  151,  213,  160,
      166,  166,  165,  160,  129,  156,  156,  156,  156,  162,
      162,  162,  162,  162,  404,  162,  162,  162,  119,  162,
      163,  163,  163,  163,  163,  165,  163,  163,  163,  164,
      163,  165,  172,  156,  156,  156,  160,  164,  167,  108,
      169,  170,  404,  167,  169,  173,  170,  173,  172,  174,
      107,  177,  175,  102,  162,  163,  177,   90,  164,  174,
      175,  178,  172,   77,  174,  163,  164,  167,  178,  169,
      170,  179,  167,  169,  173,  170,  173,  172,  179,  174,

      177,  175,  180,  180,  163,  177,  197,  197,  174,  175,
      178,  202,  202,  174,  206,  206,  206,  178,  214,  233,
      179,  218,  218,  218,  223,  223,  223,  179,  235,  223,
      236,  180,  180,  224,  224,  224,  234,  234,  224,  197,
      226,  226,  226,   76,  202,  226,   75,  214,  233,  251,
      251,  251,  253,  253,  253,  255,  255,   70,  235,   67,
      236,  276,  276,  279,  279,  234,  234,  197,  311,  311,
      312,  312,  202,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,

      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  237,
      238,  239,  240,  241,  242,  243,  244,   47,  246,  247,
      248,  249,  296,  260,   27,  257,  257,  257,  257,  257,
      260,  257,  257,  257,   24,  257,  270,   20,  237,  238,
      239,  240,  241,  242,  243,  256,  244,  246,  247,  257,

      248,  249,  296,  260,  256,  256,  259,  256,  256,  260,
      262,  261,  256,  259,  259,  270,  256,  263,  263,  262,
      257,  261,  333,  333,  258,  258,  258,  258,  258,  257,
      258,  258,  258,  267,  258,  259,  264,  267,  264,  262,
       15,  261,  259,  259,  265,  266,  263,  263,  262,  256,
      261,  258,  266,  265,  268,  271,  269,  275,  268,  271,
      272,  273,  267,  269,  272,  264,  267,  264,  273,  258,
      274,  275,  275,  265,  266,  283,  285,  274,  286,  298,
      258,  266,  265,  268,  271,  293,  269,  268,  271,  272,
      295,  273,  269,  272,  299,  300,  302,  273,  303,  305,

      274,  304,  306,  308,  283,  285,  274,  286,  275,  298,
      310,  315,  318,  316,  293,  313,  313,  314,    0,  295,
      314,  316,  323,  299,  300,  302,  319,  313,  303,  305,
      304,  306,  308,  317,    0,  320,  317,  319,  321,  310,
      315,  318,  316,  320,  322,  324,  314,  321,  325,  314,
      316,  323,  324,  327,  325,  328,  319,  329,  335,  335,
      327,  326,  322,  317,  320,  317,  319,  321,  326,  338,
      331,  330,  320,  322,  337,  324,  321,  325,  331,  332,
      340,  324,  327,  325,  328,  330,  329,  341,  347,  327,
      342,  326,  343,  332,  332,  345,  346,  326,  338,  331,

      330,  344,  344,  344,  337,  348,  349,  331,  350,  340,
      351,  344,  352,  330,  353,  355,  360,  341,  347,  342,
      357,  343,  357,  365,  345,  346,  365,  355,  358,    0,
      332,  359,  362,  359,  348,  349,  362,  350,  364,  358,
      351,  372,  352,  353,  364,  360,  361,  361,  361,  357,
      363,  357,  365,  366,  370,  365,  361,  363,  358,  366,
      359,  362,  359,  367,  368,  362,  369,  364,  358,  369,
      367,  372,  373,  364,  375,  368,  376,  374,  374,  374,
      363,  381,  366,  370,    0,  361,  363,  374,  366,    0,
      377,  377,  377,  367,  368,  369,  384,    0,  369,  367,

      377,  373,  385,  375,  368,  376,  378,  378,  378,  386,
      381,  382,  382,  382,  361,  387,  378,  383,  383,  383,
      388,  382,  391,  391,  391,  393,  384,  383,  392,  395,
      392,  385,  391,  403,  393,  394,  394,  394,  386,  398,
      396,  396,  396,  399,  387,  394,  408,  395,  398,  388,
      396,  399,  400,  402,  393,  402,  401,  392,  395,  392,
      400,  391,  403,  393,  401,  397,  397,  397,  407,  398,
      418,    0,  399,  411,  394,  397,  408,  398,  422,  396,
      399,  400,  402,  412,  402,  401,  405,  405,  405,  400,
      391,  417,  420,  401,  421,  424,  405,  407,  418,  409,

      409,  409,  411,  394,  397,  413,  413,  413,  396,  409,
      415,  415,  415,  412,  432,  413,  419,  419,  419,  425,
      415,  417,  420,  426,  421,  427,  419,  425,  428,  422,
      426,  427,  430,  397,  429,  429,  429,  433,    0,  430,
      431,  428,  436,  432,  429,  438,  424,  431,  425,  437,
      444,    0,    0,  426,    0,  427,  425,  428,    0,  426,
      427,  446,  430,  455,  434,  434,  434,  433,  430,  428,
      431,  452,  436,  429,  434,  438,  431,    0,  437,  439,
      439,  439,  440,  440,  440,  442,  442,  442,  447,  439,
      446,  447,  440,  455,    0,  442,  443,  443,  443,  456,

      452,  444,  429,  445,  445,  445,  443,  448,  448,  448,
      457,  464,  467,  445,  449,  449,  449,  448,  447,    0,
      447,  450,  450,  450,  449,  453,  453,  453,  465,  456,
      476,  450,  466,  469,    0,  453,  477,    0,    0,  457,
      464,  467,  445,  473,  470,    0,  448,  458,  458,  458,
        0,  470,  485,  449,  460,  460,  460,  458,  465,  476,
      450,  478,  466,  469,  460,  477,  462,  462,  462,  480,
        0,  445,    0,  473,  470,  448,  462,  468,  468,  468,
      470,  485,  449,  474,  474,  474,  486,  468,  486,  450,
      487,  478,  489,  474,  479,  479,  479,  481,  488,  480,

      481,  483,  483,  483,  479,  488,  490,  491,  490,  492,
      493,  483,  494,  494,  495,  486,  496,  486,  492,  497,
      487,  489,  499,  498,    0,  500,  496,  481,  488,  481,
      498,  500,  502,    0,  488,  490,  491,  490,  492,  493,
        0,  494,  494,    0,  495,    0,  496,  492,    0,  497,
      559,  499,    0,  498,  500,  496,  559,  559,  559,  498,
      500,  502,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      502,  505,  505,  505,  505,  505,  505,  505,  505,  505,

      505,  505,  505,  505,  505,  505,  505,  505,  505,  505,
      505,  505,  505,  505,  505,  505,  505,  505,  506,  506,
      506,  506,  506,  506,  506,  506,  506,  506,  506,  506,
      506,  506,  506,  506,  506,  506,  506,  506,  506,  506,
      506,  506,  506,  506,  506,  507,  507,  507,  507,  507,
      507,  507,  507,  507,  507,  507,  507,  507,  507,  507,
      507,  507,  507,  507,  507,  507,  507,  507,  507,  507,
      507,  507,  508,    0,    0,    0,  508,  508,  508,  508,
      508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
      508,  508,  508,  508,  508,  508,  508,  508,  508,  509,

      509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
      509,  509,  509,  509,  509,  509,  509,  509,  509,  509,
      509,  509,  509,  509,  509,  509,  510,  510,  510,  510,
      510,  510,  510,  511,  511,    0,  511,  511,  511,  511,
      511,  511,  511,  511,  511,  511,  511,  511,  511,  511,
      511,  511,  511,  511,  511,  511,  511,  511,  511,  511,
      512,  512,  512,  512,  512,  512,  512,  512,  512,  512,
      512,  512,  512,  512,  512,  512,  512,  512,  512,  512,
      512,  512,  512,  512,  512,  512,  512,  513,  513,  513,
        0,    0,  513,  513,    0,  513,    0,    0,  513,  513,

      513,  513,  513,  513,  513,  513,  514,  514,    0,    0,
        0,    0,  514,  514,  514,  514,  514,  514,  514,  515,
        0,  515,    0,    0,    0,  515,  515,    0,  515,    0,
        0,    0,    0,  515,    0,    0,    0,  515,  515,  515,
      515,  515,  515,  515,  516,    0,  516,    0,  516,    0,
      516,    0,    0,    0,    0,    0,  516,  516,  516,  516,
      516,  516,  516,  517,    0,    0,  517,  517,    0,  517,
      517,  517,    0,    0,    0,  517,  517,  517,  517,  517,
      517,  517,  518,  518,    0,  518,  518,  518,  518,  518,
      518,  518,  518,  518,  518,  518,  518,  518,  518,  518,

      518,  518,  518,  518,  518,  518,  518,  518,  518,  519,
        0,    0,    0,  519,    0,    0,  519,  519,    0,    0,
        0,    0,  519,  519,  519,  519,  519,  519,  519,  520,
      520,  520,  520,  520,    0,  520,  520,    0,  520,    0,
        0,  520,  520,  520,  520,  520,  520,  520,  520,  521,
      521,  521,  521,  521,  521,  521,  521,  521,  521,  521,
      521,  521,  521,  521,  521,  521,  521,  521,  521,  521,
      521,  521,  521,  521,  521,  521,  522,  522,  522,  522,
      522,  522,  522,  522,  522,  522,  522,  522,  522,  522,
      522,  522,  522,  522,  522,  522,  522,  522,  522,  522,

      522,  522,  522,  523,    0,  523,  523,    0,    0,    0,
        0,  523,  523,  523,  523,  523,  523,  523,  523,  524,
      524,  524,  524,  524,  524,  524,    0,  524,  524,  524,
      524,  524,  524,  524,  524,  524,  524,  524,  524,  524,
      524,  524,  524,  524,  524,  524,  525,    0,    0,    0,
      525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
      525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
      525,  525,  525,  526,    0,  526,  526,    0,    0,    0,
        0,  526,  526,  526,  526,  526,  526,  526,  526,  527,
      527,  527,  527,  527,  527,    0,  527,  527,  527,  527,

      527,  527,  527,  527,  527,  527,  527,  527,  527,  527,
      527,  527,  527,  527,  527,  527,  528,    0,  528,    0,
        0,    0,    0,  528,  528,    0,    0,    0,    0,    0,
        0,  528,  528,  528,  528,  528,  528,  528,  529,  529,
      529,  529,  529,  529,  529,  529,  529,  529,  529,  529,
      529,  529,  529,  529,  529,  529,  529,  529,  529,  529,
      529,  529,  529,  529,  529,  530,  530,    0,    0,    0,
        0,  530,  530,  530,  530,  530,  530,  530,  530,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,
      531,  531,  531,  531,  531,  531,  531,  531,  531,  531,

      531,  531,  531,  531,  531,  531,  532,  532,  532,  532,
      532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
      532,  532,  532,  532,  532,  532,  532,  532,  532,  532,
      532,  532,  532,  533,  533,  533,  533,  533,  533,  533,
      533,  533,  533,  533,  533,  533,  533,  533,  533,  533,
      533,  533,  533,  533,  533,  533,  533,  533,  533,  533,
      534,  534,    0,  534,  534,  534,  534,  534,  534,  534,
      534,  534,  534,  534,  534,  534,  534,  534,  534,  534,
      534,  534,  534,  534,  534,  534,  534,  535,  535,  535,
        0,    0,  535,  535,    0,  535,    0,    0,  535,  535,

      535,  535,  535,  535,  535,  535,  536,  536,  536,    0,
        0,    0,  536,  536,  536,  536,  536,  536,  536,  537,
        0,  537,    0,    0,    0,  537,  537,    0,  537,    0,
        0,    0,    0,  537,    0,    0,    0,  537,  537,  537,
      537,  537,  537,  537,  538,    0,  538,    0,  538,    0,
      538,    0,    0,    0,    0,    0,  538,  538,  538,  538,
      538,  538,  538,  539,  539,    0,  539,  539,  539,    0,
        0,    0,  539,  539,  539,  539,  539,  539,  539,  540,
        0,    0,    0,  540,    0,    0,    0,    0,    0,    0,
        0,    0,  540,  540,  540,  540,  540,  540,  540,  541,

        0,    0,  541,    0,  541,    0,  541,    0,  541,    0,
        0,  541,  541,    0,  541,  541,  541,  541,  541,  541,
      541,  542,  542,  542,  542,  542,  542,  542,  542,  542,
      542,  542,  542,  542,  542,  542,  542,  542,  542,  542,
      542,  542,  542,  542,  542,  542,  542,  542,  543,    0,
        0,    0,    0,    0,  543,  543,    0,    0,  543,  543,
      543,    0,    0,    0,  543,  543,  543,  543,  543,  543,
      543,  544,    0,    0,  544,  544,  544,  544,  544,    0,
      544,  544,    0,  544,  544,    0,  544,  544,  544,  544,
      544,  544,  544,  544,  545,  545,  545,  545,  545,    0,

      545,  545,    0,  545,    0,    0,  545,  545,  545,  545,
      545,  545,  545,  545,  546,  546,  546,  546,  546,  546,
      546,  546,  546,  546,  546,  546,  546,  546,  546,  546,
      546,  546,  546,  546,  546,  546,  546,  546,  546,  546,
      546,  547,    0,    0,    0,    0,    0,    0,    0,  547,
        0,    0,    0,    0,  547,  547,  547,    0,    0,  547,
      547,  548,  548,  548,  548,  548,  548,  548,  548,  548,
      548,  548,  548,  548,  548,  548,  548,  548,  548,  548,
      548,  548,  548,  548,  548,  548,  548,  548,  549,    0,
      549,  549,    0,    0,    0,    0,  549,  549,  549,  549,

      549,  549,  549,  549,  550,  550,  550,  550,  550,  550,
      550,    0,  550,  550,  550,  550,  550,  550,  550,  550,
      550,  550,  550,  550,  550,  550,  550,  550,  550,  550,
      550,  551,    0,    0,    0,  551,  551,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  551,  551,
      551,  551,  551,  551,  551,  551,  551,  551,  552,    0,
      552,  552,    0,    0,    0,    0,  552,  552,  552,  552,
      552,  552,  552,  552,  553,  553,  553,  553,  553,  553,
        0,  553,  553,  553,  553,  553,  553,  553,  553,  553,
      553,  553,  553,  553,  553,  553,  553,  553,  553,  553,

      553,  554,  554,    0,    0,    0,    0,    0,    0,  554,
        0,    0,    0,    0,    0,    0,  554,    0,    0,  554,
        0,  554,  555,  555,  555,  555,  555,  555,  555,  556,
        0,    0,    0,    0,    0,  556,  556,    0,  556,  556,
        0,    0,    0,    0,  556,  556,  556,  556,  556,  556,
      556,  556,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  557,
      557,  557,  557,  557,  557,  557,  557,  557,  557,  558,
      558,    0,    0,    0,    0,    0,    0,  558,    0,    0,
        0,    0,    0,    0,  558,    0,    0,  558,    0,  558,

      560,  560,    0,    0,    0,    0,  560,  560,  560,  560,
      560,  560,  560,  560,  561,  561,  561,  561,  561,  561,
      561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
      561,  561,  561,  561,  561,  561,  561,  561,  561,  561,
      561,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  562,  562,
      562,  562,  562,  562,  562,  562,  562,  562,  563,  563,
      563,  563,  563,  563,  563,  563,  563,  563,  563,  563,
      563,  563,  563,  563,  563,  563,  563,  563,  563,  563,
      563,  563,  563,  563,  563,  564,  564,  564,  564,  564,

      564,  564,  564,  564,  564,  564,  564,  564,  564,  564,
      564,  564,  564,  564,  564,  564,  564,  564,  564,  564,
      564,  564,  565,  565,    0,  565,  565,  565,  565,  565,
      565,  565,  565,  565,  565,  565,  565,  565,  565,  565,
      565,  565,  565,  565,  565,  565,  565,  565,  565,  566,
      566,    0,  566,  566,  566,  566,  566,  566,  566,  566,
      566,  566,  566,  566,  566,  566,  566,  566,  566,  566,
      566,  566,  566,  566,  566,  566,  567,  567,    0,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,
      567,  567,  567,  567,  567,  567,  567,  567,  567,  567,

      567,  567,  567,  568,  568,    0,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      568,  568,  568,  568,  568,  568,  568,  568,  568,  568,
      569,  569,  569,    0,    0,  569,  569,    0,  569,    0,
        0,  569,  569,  569,  569,  569,  569,  569,  569,  570,
        0,    0,  570,    0,  570,    0,  570,    0,  570,    0,
        0,  570,  570,    0,  570,  570,  570,  570,  570,  570,
      570,  571,  571,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,  571,  571,  571,
      571,  571,  571,  571,  572,    0,    0,  572,  572,  572,

      572,  572,    0,  572,  572,    0,  572,  572,    0,  572,
      572,  572,  572,  572,  572,  572,  572,  573,  573,  573,
      573,  573,    0,  573,  573,    0,  573,    0,    0,  573,
      573,  573,  573,  573,  573,  573,  573,  574,  574,  574,
      574,  574,  574,  574,  574,  574,  574,  574,  574,  574,
      574,  574,  574,  574,  574,  574,  574,  574,  574,  574,
      574,  574,  574,  574,  575,  575,    0,    0,    0,    0,
      575,  575,  575,  576,  576,    0,    0,    0,    0,  576,
      576,  576,  577,  577,    0,    0,    0,    0,  577,  577,
      577,  578,  578,    0,    0,    0,    0,  578,  578,  578,

      579,  579,  579,  579,  579,  579,  579,  579,  579,  579,
      579,  579,  579,  579,  579,  579,  579,  579,  579,  579,
      579,  579,  579,  579,  579,  579,  579,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,

      504,  504,  504,  504,  504,  504,  504,  504,  504,  504,
      504,  504,  504,  504
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[102] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 
    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 
    0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 
    0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2014 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
* 
*       http://www.apache.org/licenses/LICENSE-2.0
*       -or-
*       see COPYING.ASL20 in the source distribution
* 
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
#line 32 "lexer.l"
#include "config.h"
#include "parserif.h"
extern char *strdup(char*); /* somehow we do not get this from string.h... */
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* INCALL: support for the call statement */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 67 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
#if !defined(__FreeBSD__)
int fileno(FILE *stream);
#endif

#line 1556 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define INCALL 5
#define EXPR 6

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 101 "lexer.l"


 /* keywords */
#line 1754 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 505 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 3528 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 104 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 105 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 106 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 107 "lexer.l"
{ return OR; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 108 "lexer.l"
{ return AND; }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 109 "lexer.l"
{ return NOT; }
	YY_BREAK
case 7:
#line 111 "lexer.l"
case 8:
#line 112 "lexer.l"
case 9:
#line 113 "lexer.l"
case 10:
#line 114 "lexer.l"
case 11:
#line 115 "lexer.l"
case 12:
#line 116 "lexer.l"
case 13:
#line 117 "lexer.l"
case 14:
#line 118 "lexer.l"
case 15:
#line 119 "lexer.l"
case 16:
#line 120 "lexer.l"
case 17:
#line 121 "lexer.l"
case 18:
YY_RULE_SETUP
#line 121 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 122 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 123 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 124 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 22:
#line 126 "lexer.l"
case 23:
YY_RULE_SETUP
#line 126 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 127 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 128 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 129 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 130 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 131 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 132 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 30:
#line 134 "lexer.l"
case 31:
#line 135 "lexer.l"
case 32:
YY_RULE_SETUP
#line 135 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 136 "lexer.l"
{ yylval.s = strdup(yytext+1); return VAR; }
	YY_BREAK
case 34:
/* rule 34 can match eol */
YY_RULE_SETUP
#line 137 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 35:
/* rule 35 can match eol */
YY_RULE_SETUP
#line 142 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 36:
/* rule 36 can match eol */
YY_RULE_SETUP
#line 147 "lexer.l"

	YY_BREAK
case 37:
YY_RULE_SETUP
#line 148 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 150 "lexer.l"
{ parser_errmsg("invalid character '%s' in expression "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 153 "lexer.l"

	YY_BREAK
case 40:
YY_RULE_SETUP
#line 154 "lexer.l"
{ parser_errmsg("invalid character '%s' in 'call' statement"
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 157 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  BEGIN INITIAL;
				  return NAME; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 160 "lexer.l"
{ return '&'; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 161 "lexer.l"
{ return '{'; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 162 "lexer.l"
{ return '}'; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 163 "lexer.l"
{ return STOP; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 164 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 165 "lexer.l"
{ BEGIN INCALL; return CALL; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 166 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 167 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 168 "lexer.l"
{ return CONTINUE; }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 51:
YY_RULE_SETUP
#line 172 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 173 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 174 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 175 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
#line 179 "lexer.l"

	YY_BREAK
case 56:
YY_RULE_SETUP
#line 180 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
#line 183 "lexer.l"
{ yylval.objType = CNFOBJ_MAINQ;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 185 "lexer.l"
{ yylval.objType = CNFOBJ_TIMEZONE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 187 "lexer.l"
{ yylval.objType = CNFOBJ_PARSER;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 189 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 191 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 193 "lexer.l"
{ yylval.objType = CNFOBJ_RULESET;
				  BEGIN INOBJ; return BEGIN_RULESET; }
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 195 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 197 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 199 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 201 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 203 "lexer.l"
{ yylval.objType = CNFOBJ_LOOKUP_TABLE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 205 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 206 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext));
				  dbgprintf("lexer: propfilt is '%s'\n", yylval.s);
				  return PROPFILT;
				  }
	YY_BREAK
case 70:
YY_RULE_SETUP
#line 211 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 71:
#line 213 "lexer.l"
case 72:
#line 214 "lexer.l"
case 73:
/* rule 73 can match eol */
#line 215 "lexer.l"
case 74:
/* rule 74 can match eol */
#line 216 "lexer.l"
case 75:
/* rule 75 can match eol */
#line 217 "lexer.l"
case 76:
/* rule 76 can match eol */
#line 218 "lexer.l"
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 218 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 78:
YY_RULE_SETUP
#line 219 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 79:
YY_RULE_SETUP
#line 220 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 80:
#line 223 "lexer.l"
case 81:
#line 224 "lexer.l"
case 82:
#line 225 "lexer.l"
case 83:
YY_RULE_SETUP
#line 225 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 226 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
/*yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }*/
case 85:
YY_RULE_SETUP
#line 233 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 86:
YY_RULE_SETUP
#line 234 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 87:
YY_RULE_SETUP
#line 235 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 88:
YY_RULE_SETUP
#line 236 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
#line 237 "lexer.l"

	YY_BREAK
case 90:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 238 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 239 "lexer.l"

	YY_BREAK
case 92:
YY_RULE_SETUP
#line 240 "lexer.l"
{ parser_errmsg("invalid character '%s' in object definition "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case 93:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 243 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 94:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 254 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 95:
/* rule 95 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 255 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 96:
/* rule 96 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 256 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 97:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 257 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 98:
/* rule 98 can match eol */
YY_RULE_SETUP
#line 258 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 99:
/* rule 99 can match eol */
YY_RULE_SETUP
#line 259 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 260 "lexer.l"
{ parser_errmsg("invalid character '%s' "
					        "- is there an invalid escape sequence somewhere?",
						yytext); }
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(INCALL):
case YY_STATE_EOF(EXPR):
#line 263 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 265 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2402 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 505 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 505 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 504);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 265 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
	dbgprintf("config parser: pushed file %s on top of stack\n", fname);

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	dbgprintf("config parser: reached end of file %s\n", bs->fn);
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL) {
		dbgprintf("config parser: parsing completed\n");
		return 1; /* all processed */
	}
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	dbgprintf("config parser: resume parsing of file %s at line %d\n",
		  cnfcurrfn, yylineno);
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

